#pragma once

#include "BASSCDRipperDefs.h"
#include "afxwin.h"

#define MAXDRIVES 16

class CCD_RIPPERDlg : public CDialog
{
public:
	CCD_RIPPERDlg(CWnd* pParent = NULL);	// standard constructor

	enum { IDD = IDD_CD_RIPPER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	HICON m_hIcon;
	bool m_bRipping;
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()

	void EnumerateDrives();
	void InitializeTracksIfNeeded(int nDrive, LPCTSTR szDrive, LPCTSTR szDirectory, LPCTSTR szExtension);
	void InitBASS();
	void Error(LPCTSTR szErrorMsg);
	static void __stdcall OnProgress(LPVOID BASSCDRipper, UINT Progress, UINT TotalProgress);
	static void __stdcall WMAEncBefore(LPVOID BASSCDRipper, UINT WMAEncodingHandle, int Track);
	LPVOID m_pBASSCDRipper;

	CComboBox m_opticalDrives;
	CString m_strOutputFile;
	int m_nAlbumMode;
	CString m_strProgress;
	int m_nResample;
	int m_nResampleFreq;
	int m_nResampleChan;
	CComboBox m_wmaKbps;
	int m_nVbr;
	int m_nPro;
	CString m_strKbps;
	int m_nTrack;
	CString m_strEncoderCmdLine;

public:
	afx_msg void OnBnClickedRipWav();
	afx_msg void OnBnClickedStopRip();
	afx_msg void OnBnClickedQuery();
	afx_msg void OnBnClickedVbr();
	afx_msg void OnBnClickedPro();
	afx_msg void OnBnClickedRipSingleTrack();
	afx_msg void OnBnClickedRipWma();
	afx_msg void OnBnClickedRipExternalEncoder();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
};
