#pragma once

#define NO_CD_CHANNEL	1
#define ERROR_WRITING	2
#define ERROR_CDSTREAM	3
#define ERROR_STARTINGENCODINGREC	4

#define FORMAT_WAV	1
#define FORMAT_ENC	2
#define FORMAT_WMA	3

#define NAME_BASSCDRipperCreate					"BASSCDRipper_Create"
#define NAME_BASSCDRipperFree					"BASSCDRipper_Free"
#define NAME_BASSCDRipperRipp					"BASSCDRipper_Ripp"
#define NAME_BASSCDRipperStopRipp				"BASSCDRipper_StopRipp"
#define NAME_BASSCDRipperGetLastError			"BASSCDRipper_GetLastError"
#define NAME_BASSCDRipperSetProgressCallback	"BASSCDRipper_SetProgressCallback"
#define NAME_BASSCDRipperSetWMAEncCallback		"BASSCDRipper_SetWMAEncCallback"
#define NAME_BASSCDRipperSetGetChannelCallback	"BASSCDRipper_SetGetChannelCallback"
#define NAME_BASSCDRipperSetCDDataProcCallback  "BASSCDRipper_SetCDDataProcCallback";
#define NAME_BASSCDRipperSetParams				"BASSCDRipper_SetParams"
#define NAME_BASSCDRipperGetParams				"BASSCDRipper_GetParams"
#define NAME_BASSCDRipperClearTracks			"BASSCDRipper_ClearTracks"
#define NAME_BASSCDRipperAddTracks				"BASSCDRipper_AddTracks"
#define NAME_BASSCDRipperRippTrack				"BASSCDRipper_RippTrack"

#define BASSCDRipperDLL	_T("BASSCDRipper.dll")

typedef  void (__stdcall *t_OnProgress)(LPVOID BASSCDRipper, UINT Progress, UINT TotalProgress);
typedef  void(*t_WMAEncBefore)(LPVOID BASSCDRipper, UINT WMAEncodingHandle, int Track);
typedef  void(*t_GetChannel)(LPVOID BASSCDRipper, UINT ChannelHandle, int Track);

typedef struct _TBASSCDRipperParams
{
	UINT Drive;
	bool AlbumMode;
	LPTSTR FileName;
	UINT Format;
	LPTSTR EncCmdLine;
	bool NoWAVHeader2Encoder;
	UINT EncoderPriority;
	bool Resample;
	DWORD ResampleFreq;
	DWORD ResampleChannels;
	DWORD ResampleFlags;
	UINT WMAEncFlags;
	int WMAQuality;
} *PBASSCDRipperParams, TBASSCDRipperParams;

typedef LPVOID(__stdcall *t_BASSCDRipper_Create)();
typedef bool(__stdcall *t_BASSCDRipper_Free)(LPVOID BASSCDRipper);
typedef bool(__stdcall *t_BASSCDRipper_Ripp)(LPVOID BASSCDRipper);
typedef bool(__stdcall *t_BASSCDRipper_StopRipp)(LPVOID BASSCDRipper);
typedef int(__stdcall *t_BASSCDRipper_GetLastError)(LPVOID BASSCDRipper);
typedef bool(__stdcall *t_BASSCDRipper_SetProgressCallback)(LPVOID BASSCDRipper, LPVOID Callback);
typedef bool(__stdcall *t_BASSCDRipper_SetWMAEncCallback)(LPVOID BASSCDRipper, LPVOID Callback);
typedef bool(__stdcall *t_BASSCDRipper_SetGetChannelCallback)(LPVOID BASSCDRipper, LPVOID Callback);
typedef bool(__stdcall *t_BASSCDRipper_SetCDDataProcCallback)(LPVOID BASSCDRipper, LPVOID Callback, LPVOID User);
typedef bool(__stdcall *t_BASSCDRipper_SetParams)(LPVOID BASSCDRipper, TBASSCDRipperParams Params);
typedef bool(__stdcall *t_BASSCDRipper_GetParams)(LPVOID BASSCDRipper, PBASSCDRipperParams Params);
typedef bool(__stdcall *t_BASSCDRipper_ClearTracks)(LPVOID BASSCDRipper);
typedef bool(__stdcall *t_BASSCDRipper_AddTracks)(LPVOID BASSCDRipper, LPTSTR TrackSaveFileName);
typedef bool(__stdcall *t_BASSCDRipper_RippTrack)(LPVOID BASSCDRipper, int Track, LPTSTR TrackSaveFileName);

namespace BASSCDRipper
{
	bool InitBASSCDRipperLibrary();
	bool FreeBASSCDRipperLibrary();

	extern t_BASSCDRipper_Create BASSCDRipper_Create;
    extern t_BASSCDRipper_Free BASSCDRipper_Free;
    extern t_BASSCDRipper_Ripp BASSCDRipper_Ripp;
    extern t_BASSCDRipper_StopRipp BASSCDRipper_StopRipp;
    extern t_BASSCDRipper_GetLastError BASSCDRipper_GetLastError;
    extern t_BASSCDRipper_SetProgressCallback BASSCDRipper_SetProgressCallback;
    extern t_BASSCDRipper_SetWMAEncCallback BASSCDRipper_SetWMAEncCallback;
    extern t_BASSCDRipper_SetGetChannelCallback BASSCDRipper_SetGetChannelCallback;
    extern t_BASSCDRipper_SetCDDataProcCallback BASSCDRipper_SetCDDataProcCallback;
    extern t_BASSCDRipper_SetParams BASSCDRipper_SetParams;
    extern t_BASSCDRipper_GetParams BASSCDRipper_GetParams;
    extern t_BASSCDRipper_ClearTracks BASSCDRipper_ClearTracks;
    extern t_BASSCDRipper_AddTracks BASSCDRipper_AddTracks;
    extern t_BASSCDRipper_RippTrack BASSCDRipper_RippTrack;
};
